import config
import message
from core.checker import BaseChecker, share
from core.textparser import TextParser


class Application(BaseChecker):

    def __init__(self):
        super().__init__('application')
        self.initial_info_collection_file()

    @share
    def application(self):
        """
        诊断思路：取DB9500E_B3323中的application.properties的内容行数（不包含空行和注释）作参考
        """
        out = self.cmd(r"cat /bigdata/salut/components/jetty/resources/application.properties | grep -Ev '\s*#'")
        line = self.cmd(r"cat /bigdata/salut/components/jetty/resources/application.properties | grep -Ev '\s*#' | wc -l")
        parser = TextParser(line.stdout)
        rows = parser.parse_rows(
            '{line_num:d}', full_match=False)
        return rows

    def run(self) -> None:
        rows = self.application()
        for row in rows:
            if row['line_num'] < config.row_num:
                self.alarms.add(message.application配置内容可能不完整.format(row['line_num']))



