import config
import message
from core.checker import BaseChecker, share
from core.textparser import TextParser
from decimal import Decimal
import os


class BigDirectory(BaseChecker):

    def __init__(self):
        super().__init__('大文件目录')
        self.dir = []
        self.initial_info_collection_file()

    @share
    def big_directory(self) -> list:
        self.recursion_directory(config.big_directory_init_path)
        #TODO 可以考虑将非最终目录的数据去除掉，暂时没做
        return self.dir

    def recursion_directory(self, path:str) -> None:
        """
        获取大文件目录
        :param
        :return:
        """
        out = self.cmd(f'du -s {path} | grep -v index | grep -v backupMsg')
        if out != None or out != ' ':
            parser = TextParser(out.stdout)
            value_list = parser.parse_rows('{capacity}{:s}{dir}')
            for item in value_list:
                dir_size = Decimal(int(item.get('capacity')) / 1024 / 1024).quantize(Decimal("0.00"))
                if dir_size > config.directory_size and os.path.isdir(item.get('dir')):
                    self.alarms.add(message.大文件目录.format(item.get('dir'), dir_size))
                    self.dir.append(item)
                    self.recursion_directory(item.get('dir')+'/*')

    def run(self) -> None:
        self.big_directory()


class LogDirectory(BaseChecker):

    def __init__(self):
        super().__init__('日志占用信息')
        self.dir = []
        self.initial_info_collection_file()

    @share
    def log_directory(self, path) -> list:
        """
        获取日志目录占用情况
        :param
        :return:
        """
        # TODO 这个可以考虑检查大小增长快的日志目录，目录更新频繁的目录
        out_seperate = self.cmd(f'du -s {path}*')
        parser = TextParser(out_seperate.stdout)
        return  parser.parse_rows('{capacity}{:s}{dir}')

    def run(self) -> None:
        self.log_directory(config.log_directory)
