from core.checker import BaseChecker, share
from core.textparser import TextParser


class Cluster(BaseChecker):

    def __init__(self):
        super().__init__('集群基本信息')
        self.initial_info_collection_file()

    @share
    def db_bigdata(self) -> dict:
        """
        获取集群配置新信息
        :param
        :return: 返回配置信息
        """
        out = self.cmd(r"cat /bigdata/salut/conf/db_bigdata.conf | grep -vE '\s*#'")
        parser = TextParser(out.stdout)
        props = parser.parse(
            'roles={roles}',
            'local_ip={local_ip}',
            'master={master}',
            'slave={slaves:comma_split}')
        nodes = parser.parse_rows('node{node_id:d}={ip}')
        props.update(dict(nodes=nodes))
        out = self.cmd(r"cat /bigdata/salut/conf/db_global.conf | grep -vE '\s*#'")
        parser = TextParser(out.stdout)
        ha = parser.parse('ISTWINS={is_ha}')
        if ha == 'True' or ha == 'true':
            ha = True
        else:
            ha = False
        props.update(dict(is_ha=ha))
        return props

    def run(self) -> None:
        self.db_bigdata()
