import message
from core.checker import BaseChecker, share
from core.textparser import TextParser


class FlumeLog(BaseChecker):

    def __init__(self):
        super().__init__('FlumeLog')

    @share
    def errorlog(self) -> dict:
        """
        只在主节点上执行该方法
        """
        if self.should_run():
            self.initial_info_collection_file()
            out = self.cmd(f'cat /var/log/dblog/salut/flume/flume.log | grep -w ERROR | wc -l')

            if out and out.stdout.strip() != '':
                parser = TextParser(out.stdout)
                return parser.parse_rows('{error_count}')

        return {}

    def run(self) -> None:
        rets = self.errorlog()
        if rets and len(rets) > 0:
            for ret in rets:
                self.alarms.add(message.Flume中存在异常.format(ret['error_count']))
