import message
from core.checker import BaseChecker, share
from core.textparser import TextParser
from core.reflection import get_cluster_info


class Hosts(BaseChecker):

    def __init__(self):
        super().__init__('主机名')
        self.initial_info_collection_file()

    @share
    def hosts(self):
        out = self.cmd('cat /etc/hosts')
        parser = TextParser(out.stdout)
        hosts = parser.parse_rows('{ip}{:s}{hostname}')

        return hosts

    def run(self) -> None:
        hosts = self.hosts()
        nodes = list(item['ip'] for item in get_cluster_info().get('nodes'))
        missing = set(nodes) - set([n['ip'] for n in hosts])
        if len(missing) > 0:
            self.alarms.add(message.HOSTS文件不完整.format(', '.join(missing)))
