from core.checker import BaseChecker, CheckerManager,share
from core.textparser import TextParser
from checkers.cluster import Cluster
import message


class Redis(BaseChecker):

    def __init__(self):
        super().__init__('redis')
        self.service_state = None
        self.props = None
        self.initial_info_collection_file()

    @share
    def redis_status(self) :
        value = {}
        self.props = CheckerManager.share(Cluster, "db_bigdata")
        if self.props['master'] == self.props['local_ip']:
            out = self.cmd("redis-cli -a admin_123 -c --cluster check " + self.props['master'] + ":9000")
            parser = TextParser(out.stdout)
            value = parser.parse('[{masters}] 0 keys in 3 masters.'
                                 , '[{all_nodes_agree}] All nodes agree about slots configuration.'
                                 , '[{slots}] All 16384 slots covered.')
            for key, value in value.items():
                if value != 'OK':
                    self.alarms.add(message.redis异常.format(key, value))

        return value

    def run(self) -> None:
        self.redis_status()





