from core.checker import BaseChecker, share
from core.textparser import TextParser
from core.common import del_empty


class Specification(BaseChecker):

    def __init__(self):
        super().__init__('specification')

    @share
    def get_specification(self, passwd:str) -> list:
        """
        只在主节点上执行该方法
        """
        if self.should_run() and passwd.strip() != '':
            self.initial_info_collection_file()
            out = self.pgsql(
                'bigdata', passwd
                 , "select tds.description, tds.max_specification, tds.curr_specification, tds.specification_ratio, tds.avg_inventory, ttc.ttl_value, tds.max_inventory_specification, tds.curr_inventory_specification, tds.inventory_specification_ratio from tbl_data_specification tds left join tbl_ttl_config ttc on  ttc.ttl_data_type = tds.data_type"
            )

            parser = TextParser(
                        out.stdout,
                        strip_header='---------------------------------',
                        strip_tail='({:d} rows)'
            )

            tasks = parser.parse_rows_by_spilt('|', ['description', 'max_specification', 'curr_specification'
                , 'specification_ratio', 'avg_inventory'
                , 'ttl_value', 'max_inventory_specification'
                , 'curr_inventory_specification', 'inventory_specification_ratio'])

            return tasks

    @share
    def pg_passwd(self) -> str:
        """
        只在主节点上执行该方法
        """
        if self.should_run():
            self.initial_info_collection_file()
            out = self.cmd(
                "unipd_64 1 `cat /bigdata/salut/components/jetty/resources/application.properties | grep -Ev '\s*#' | grep -w tollgate.jdbc.password | cut -d= -f 2`")
            return del_empty(out.stdout)

        return ''

    def run(self) -> None:
        passwd = self.pg_passwd()
        self.get_specification(passwd)




