from core.checker import BaseChecker, CheckerManager,share
from core.textparser import TextParser
from checkers.cluster import Cluster
from checkers.dbserver import DBServer
import json
import config


class Yarn(BaseChecker):

    def __init__(self):
        super().__init__('yarn')
        self.props = None
        self.version = None
        self.initial_info_collection_file()

    @share
    def yarn_mission_status(self) -> list:
        """
        只在主节点上执行该方法
        """
        if self.should_run():
            self.initial_info_collection_file()
            self.props = CheckerManager.share(Cluster, "db_bigdata")
            self.version = CheckerManager.share(DBServer, 'version')
            port = 8188
            parser = TextParser(self.version['exter_version'])
            # TODO 暂时只匹配B3333及之后的版本
            version_detail = parser.parse_rows('{type}5.0-B33{version}.{version_D}.{version_SP}.{date}', full_match=True)
            # DBF9500F-IMOS110-B3326H534
            if int(version_detail[0]['version']) < config.yarn_resource_manager_55 and int(version_detail[0]['version_SP']) != 111:
                port = config.port_yarn_resource_manager_before_55['Yarn_ResourceManager']

            out = self.http('GET', self.props['local_ip'], port, '/ws/v1/cluster/appstatistics')
            parser = TextParser(out.output)

            return parser.parse_json(json.loads(parser.text))

    def run(self) -> None:
        self.yarn_mission_status()





