import message
from core.checker import BaseChecker, share
from core.textparser import TextParser


class ZookeeperLog(BaseChecker):

    def __init__(self):
        super().__init__('ZookeeperLog')

    @share
    def errorlog(self) -> dict:
        """
        只在主节点上执行该方法
        """
        if self.should_run():
            self.initial_info_collection_file()
            out_hostname = self.cmd('hostname')
            parser_hostname = TextParser(out_hostname.stdout)
            node_id = parser_hostname.parse('{nodeid}')
            out = self.cmd(f'cat /var/log/dblog/zookeeper/zookeeper-root-server-{node_id["nodeid"]}.log')

            if out and out.stdout.strip() != '':
                parser = TextParser(out.stdout)
                return parser.parse('[{date}] [{}] - [ERROR] [{program}] - {info}')

        return {}

    def run(self) -> None:
        ret = self.errorlog()
        if ret.get('date') and ret.get('info'):
            self.alarms.add(message.zookeeper_io_exception.format(ret['date'], ret['info']))

