#################################
# 基本配置
#################################


# checker所在的包名，程序根据此包名扫描可用的Checker
cluster_type = 'cluster.dbe.DBE'
# 最大线程数，用于多节点并行文件分发和信息收集
max_thread_num = 10
# # 临时信息输出目录
tmp_output_dir = 'tmp'
# 最终信息输出目录
output_dir = 'output'
# 日志文件名称
log_file_name = 'cluster-checker.log'
# 分发路径
dispatch_path = '/tmp/cluster-checker'
# http监听端口
http_server_port = 11111
# db_bigdata.conf配置文件位置
db_bigdata_path = "/bigdata/salut/conf/db_bigdata.conf"
# db_global.conf配置文件位置
db_global_path = "/bigdata/salut/conf/db_global.conf"
# service.json各服务启动/停止配置文件位置
service_path = "/bigdata/salut/conf/service.json"
# 磁盘检测是排除逻辑卷
exclude_mapper= "/dev/mapper"
# 检测application.properties内容完整性的阈值
row_num = 197
# 检测常用服务端口是否正常
a = {'1': 1, '2': 2, '3': 3, '4': 4}
port_common = {'Zookeeper': 2181, 'HDFS_NameNode': 50070, 'HBase_Master': 16010, 'Elasticsearch': 9200, 'Kibana': 5601, 'Kafka': 9092, 'PostgreSQL': 5432, 'GreenPlum': 6543, 'MasterServer': 19098, 'SlaveServer': 9099, 'IrisServer':9100, 'FeatureSlave': 18000, 'FeatureMaster': 18001, 'Nginx': 8094, 'Bgclient': 8103}
port_jetty_before_51 = {'Jetty': 80}
port_jetty_after_51 = {'Jetty': 4051}
port_yarn_resource_manager_before_55 = {'Yarn_ResourceManager': 8088}
port_yarn_resource_manager_after_55 = {'Yarn_ResourceManager': 8188}
# Jetty端口更改版本
jetty_51 = 51
# Yarn_ResourceManager端口改变版本
yarn_resource_manager_55 = 55
yarn_resource_manager_51P111 = 51.111
# 磁盘大文件目录初始扫描路径
big_directory_init_path = '/*'
# 磁盘大文件目录检测阈值(GB)
directory_size = 200
# 日志占用信息
log_directory = "/var/log/dblog/"
# 递归搜索大文件目录时的深度
recursion_depth = 100

#################################
# 模拟数据配置
#################################

# 使用模拟数据，用于单元测试。开启后将使用预置用例模拟命令或函数调用的返回结果
mock_enable = False
# 模拟数据所在目录
mock_dir = 'mock/suit1'
# 模拟数据Xml文件标签名
xml_tag_root = 'Cases'
xml_tag_operation = 'Case'
xml_tag_output = 'Output'
xml_tag_error = 'Error'
xml_tag_code = 'Code'
xml_tag_http_body = 'Body'

#################################
# 故障诊断配置
#################################

# 关键目录配置
key_dirs = {
    '/bigdata/salut/data': {
        'expect_size_gb': 1000,
        'min_write_mb_per_second': 100,
        'min_read_mb_per_second': 100
    },
    '/data2': {
        'expect_size_gb': 1000,
    },
    '/index': {
        'expect_size_gb': 1000,
    },
    '/var/log': {
        'expect_size_gb': 300,
    },
}
# 最大磁盘使用百分比
disk_max_used_percent = 85
# 磁盘使用百分比告警百分比
disk_warn_used_percent = 75
# 最小磁盘剩余空间
disk_min_available_gb = 100
# 最大线程数
thread_max_num = 100
# 最小核数
cpu_min_vcore = 24
# 最大内核cpu占用
cpu_max_sys = 10
# 最大iowait
cpu_max_wa = 10
# 最大用户cpu占用
cpu_max_user = 50
# 最小剩余空间
memory_min_free_gb = 5
# 最小总内存空间
memory_min_total_gb = 115
# 最大ping延迟毫秒数
network_max_ping_ms = 10
# kafka每个分区最大允许堆积数据量
kafka_max_partition_lag = 10000
# 最小服务器运行时间，小于这个时间给出警告
uptime_min_days = 30
# 重点关注的易缺失的Linux命令
cmd_missing = ['ssh-copy-id', 'curl']
# kafka完整topic
kafka_all_topics = ['Alarm', 'FaceControl', 'FaceControlResult', 'Panorama', 'Statistics', 'ViidMotorVehicle', '__consumer_offsets', 'customintegral', 'environmentrecord', 'face_alarm_data', 'face_dispose_feature', 'face_image', 'face_image_feature', 'face_image_forward', 'hrecord', 'mac', 'pedestrianviolation', 'person_file_feature', 'person_trace', 'rfid_record', 'rfidalarm', 'rfidalarmfence', 'rfidalarmlock', 'static_face_base', 'statistics_halarm', 'statistics_hrecord', 'statistics_mac', 'third_engine_feature', 'traffic_event', 'traffic_flow_record', 'unclassified_person_trace', 'vehicle_alarm', 'vehicle_file', 'vehicle_file_feature', 'vehicle_image_feature', 'video_person', 'video_person_feature', 'videoconcentration', 'virtual_mac', 'wa_basic_fj']


