from core.common import Msg

核数过少 = Msg(
    level='严重',
    description='CPU核数过少，只有{:d}个, 要求{:d}个',
)
线程数过大 = Msg(
    level='严重',
    description='线程数过大，达到{:d}， 超出阈值：{:d}\n线程最多的进程：\n{}'
)
服务运行时间短 = Msg(
    level='一般',
    description='服务器运行时间仅为{:d}天，如果发现数据损坏考虑近期是否有断电或异常关机'
)
负载高 = Msg(
    level='一般',
    description='系统负载过高，近1分钟{:.2f}，近5分钟{:.2f}，近15分钟{:.2f}，建议负载不超过{:.2f}'
)
内核CPU占用高 = Msg(
    level='一般',
    description='内核CPU占用偏高({:f}%)，正常不超过{:f}%'
)
用户CPU占用高 = Msg(
    level='一般',
    description='用户CPU占用偏高({:f}%)，正常不超过{:f}%'
)
CPU_IO等待时间高 = Msg(
    level='一般',
    description='CPU IO等待时间偏高({:f}%)，正常不超过{:f}%'
)
服务未启动 = Msg(
    level='严重',
    description='以下服务未运行：{}，请尝试手动启动'
)
磁盘总容量不足 = Msg(
    level='严重',
    description='磁盘 {} 总容量只有 {} GB，未达到要求 {} GB，建议更换符合要求的磁盘\n容量需求如下：\n{}',
)
磁盘剩余容量不足 = Msg(
    level='严重',
    description='磁盘 {} 容量仅剩 {} GB，低于阈值 {} GB，可能引起flume、ElasticSearch、Deamon服务的异常； 如果服务异常现象已经出现，请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》2.7 flume节内容进行修复'
)
磁盘使用比例过高 = Msg(
    level='严重',
    description='磁盘 {} 使用比例过高 {} %，超出阈值 {} %,可能引起flume、ElasticSearch、Deamon服务的异常； 如果服务异常现象已经出现，请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》2.7 flume节内容进行修复',
)
磁盘使用比例较高 = Msg(
    level='告警',
    description='磁盘 {} 使用比例达 {} %，注意阈值为 {} %, 可能引起flume、ElasticSearch、Deamon服务的异常； 如果服务异常现象已经出现，请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》2.7 flume节内容进行修复'
)
磁盘故障 = Msg(
    level='严重',
    description='SMART信息显示，磁盘 {} 存在故障，建议更换磁盘'
)
磁盘不支持SMART命令 = Msg(
    level='一般',
    description='磁盘\'{}\'不支持SMART命令'
)
磁盘写入慢 = Msg(
    level='严重',
    description='目录 {} 所在磁盘写入性能较差, {} MB/s，预期 {} MB/s'
)
索引red = Msg(
    level='严重',
    description='索引异常(red)：{}，请参考《大数据DBE_S_F局点问题FAQ-v2.0。1》=》2.3.2 ES 单索引red内容进行操作'
)
索引yellow = Msg(
    level='一般',
    description='索引不健康(yellow)：{}， 请参考FAQxxx章节修复'
)
ES长任务 = Msg(
    level='严重',
    description='ES中存在执行时间超过 {} 的任务 {}'
)
ES索引只读 = Msg(
    level='严重',
    description='ES中存在如下只读索引: [{}]，请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》2.3.1 ES只读 节内容进行操作'
)
GP集群不健康 = Msg(
    level='严重',
    description='GP集群不健康，请参考FAQxxx章节修复'
)
GP长任务 = Msg(
    level='严重',
    description='GreenPlum中存在执行{}小时的SQL语句: {}， pid为：{}, 可执行以下SQL语句终止该语句：select pg_terminate_backend({}))',
)
HDFS坏块 = Msg(
    level='严重',
    description='{:d}个块损坏，占比{:.3f} %， 请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》2.1 HDFS节内容进行修复'
)
HBase不一致 = Msg(
    level='严重',
    description='HBase存在 {} 个不一致，涉及表：{}，请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》2.2 HBase节内容进行修复'
)
HOSTS文件不完整 = Msg(
    level='严重',
    description='hosts文件中未完整添加集群中所有节点，以下节点缺失：{}'
)
Kafka数据堆积 = Msg(
    level='严重',
    description='消费者组 {} 中，{} 的各个分区数据最少堆积 {}, 最多堆积{} 条，共堆积 {} 条，请间隔10秒，使用\" appOffsetChecker.sh 消费者组名称\" 重复执行这条命令，观察\"CURRENT\"、\"END\"、\"LAG\"这几项参数后面的数字是否变化，重点观察\"CURRENT\"数字是否减少，如果减少则表示Kafka消费正常，否者检查flume日志，或者查看故障告警目录下的FlumeLog.txt文件'
)
Swap未禁用 = Msg(
    level='严重',
    description='Swap应当禁用，当前swap空间{}G，使用{}G，请参考FAQxxx章节修复'
)
内存剩余不足 = Msg(
    level='严重',
    description='空闲内存不足 {} G, 建议 {} G'
)
内存总容量不足 = Msg(
    level='严重',
    description='内存总容量不足（{} G）, 建议 {} G'
)
网络丢包率高 = Msg(
    level='严重',
    description='与节点{}网络存在故障 ，丢包率 {} %'
)
网络延迟高 = Msg(
    level='严重',
    description='与节点{}平均延迟过高：{} ms，大于预期 {} ms'
)
SSH无秘钥 = Msg(
    level='严重',
    description='当前节点与以下节点之间的SSH无秘钥未配置或存在异常：{}，请手动修复'
)
命令缺失 = Msg(
    level='严重',
    description='缺少必须的命令：{}, 请参照《大数据DBE_S_F局点问题FAQ-v2.x》=》\"1.3 GP无法启动小节问题解决方式来解决问题\" 或者 \"3.2.1 安装时频繁输入密码中方式进行解决\"'
)
application配置内容可能不完整 = Msg(
    level='告警',
    description='application.properties有效内容行数为 {}，内容可能不完整'
)
端口未监听 = Msg(
    level='严重',
    description='服务 {} 的端口 {} 未监听'
)
redis异常 = Msg(
    level='严重',
    description='{} 状态为 {}，请检查redis服务'
)
大文件目录 = Msg(
    level = '告警',
    description = '目录 {} 的大小为 {} GB，该目录大小是否适当？'
)
zookeeper_io_exception = Msg(
    level = '严重',
    description = '故障日志时间：{};zookeeper服务存在异常:\"{}\"; 请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》2.4 Zookeeper 服务异常节内容进行修复;'
)

Kafka当前缺失的Topic = Msg(
    level = '严重',
    description = 'Kafka当前存在缺少Topic的情况, 缺少的Topic如下: {}, 请确认这些缺少的Topic是否对业务造成影响, 请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》2.5.1 Topic缺失节内容进行修复;'
)

Kafka崩溃的Topic = Msg(
    level = '严重',
    description = '时间: {}, Kafka当前存在崩溃的Topic: {}, 请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》\"2.5.2 index崩溃或者2.5.3 多个index崩溃（Topic暴力重建）节\"内容进行修复;'
)

Flume中存在异常 = Msg(
    level = '严重',
    description = 'Flume日志\'/var/log/dblog/salut/flume/flume.log\'当前存在\"{}\"处异常, 请参考《大数据DBE_S_F局点问题FAQ-v2.x》=》\"3.1 接入问题\"节内容参考比对，如果不是FAQ中记录的异常, 请联系研发;'
)